import sys
from subprocess import Popen, PIPE
from bzrlib.transport import get_transport
from urlparse import urlsplit, urlunsplit
def patch(branch, location, strip):
    """Apply a patch to a branch, using patch(1).  URLs may be used."""
    my_file = None
    if location is None:
        my_file = sys.stdin
    else:
        for prefix in ('http://', 'sftp://', 'file://'):
            if not location.startswith(prefix):
                continue
            (scheme, loc, path, query, fragment) = urlsplit(location)
            loc_start = urlunsplit((scheme, loc, '/', '', ''))
            my_file = get_transport(loc_start).get(path[1:])
        if my_file is None:
            my_file = file(location, 'rb')
    cmd = ['patch', '--directory', branch.base, '--strip', str(strip)]
    child_proc = Popen(cmd, stdin=PIPE)
    for line in my_file:
        child_proc.stdin.write(line)
    child_proc.stdin.close()
    return child_proc.wait()
